Kde help search fails too quietly if htdig is not installed

Bug #19767 reported by Stuart Gilberd on 2005-08-16
162
This bug affects 4 people
Affects Status Importance Assigned to Milestone
kdebase (Debian)
Fix Released
Unknown
kdebase-runtime (Ubuntu)
Medium
Unassigned
Declined for Jaunty by Jonathan Thomas
Declined for Karmic by Jonathan Thomas

Bug Description

htdig should be a dependecy of the base kde packages

Kde 3.4.2 (and older versions)

To reproduce:
* open help for the first time
* enter something in the search box
* a dialog informs you that the index needs to be built
* step through the index building process, ticking application manuals in the what to index step
* click build index.
* the dialog tells you its 100% done (Index creation finished) - yay!
* but in reality if you happen to click details you see something like the following:

INDEXDIR: /home/sgilberd/.kde/share/apps/khelpcenter/index/
FINDCMD: find /usr/share/doc/kde/HTML/en/ -name index.docbook
Creating index for 'kde_application_manuals'
htdig failed

Alternatively you can reproduce this by using "Settings->Build Search index"

Installing htdig from synaptic fixes the problem.

# Automatically generated email from bts, devscripts version 2.8.14
 # _if_ it is a missing Depends, it is serious
severity 313375 serious

On June 13, 2005 06:50, Andreas Pakulat wrote:
> I just wanted to create a search index for the helpcenter but couldn't
> as it's missing htdig. If indexing is not possible without htdig,
> khelpcenter should depend on it. I wasn't sure if this is a severe
> policy violation, thus only used severity: important instead of
> serious...

If you install htdig, does it work? Even with htdig installed, I can't get
KHelpCenter to actually index the handbooks, though it tells me that it
succeeded. A quick google revealed a large number of people with similar
problems. See KDE bug #102912 and Gentoo bug #89515 for a sample.

Unless there is some trick I'm missing, I suspect that this feature is
simply broken, or at least unsupported by Debian's htdig.

Cheers,
Christopher Martin

On June 13, 2005 10:28, Christopher Martin wrote:
> Unless there is some trick I'm missing

Indeed.

FINDCMD: find /usr/share/doc/HTML/en/ -name index.docbook
Creating index for 'kde_application_manuals'
find: /usr/share/doc/HTML/en/: No such file or directory

Perhaps the only problem is simply that it isn't using Debian's correct path
of /usr/share/doc/kde/HTML/en/. Let's try patching that and see what
happens...

On June 13, 2005 10:36, Christopher Martin wrote:
> Perhaps the only problem is simply that it isn't using Debian's correct
> path of /usr/share/doc/kde/HTML/en/. Let's try patching that and see what
> happens...

Still doesn't work:

FINDCMD: find /usr/share/doc/kde/HTML/en/ -name index.docbook
Creating index for 'kde_application_manuals'
Warning: unknown locale!

New server: home, 80
Unknown host: home
0:0:0:file://home/chris/.kde/share/apps/khelpcenter/ \
index/kde_application_manuals.tmp/index.html: \
---------------------------------------- size = 12663
htdig: Run complete
htdig: 1 server seen:
htdig: home:80 1 document
Finished successfully.

I noticed that htdig's debconf prompts mentioned the existence of an
htdig3.2 package, yet I couldn't find it in the archive. It is available
from http://users.linuxbourg.ch/ribnitz/debian, however, and while I now
get a much longer and more promising set of errors, no index.

On 13.Jun 2005 - 11:20:42, Christopher Martin wrote:
> On June 13, 2005 10:36, Christopher Martin wrote:
> > Perhaps the only problem is simply that it isn't using Debian's correct
> > path of /usr/share/doc/kde/HTML/en/. Let's try patching that and see what
> > happens...
>
> Still doesn't work:

Here khelpcenter crashes when I do a symlink from /u/s/d/kde/HTML ot
/u/s/d/HTML...

> FINDCMD: find /usr/share/doc/kde/HTML/en/ -name index.docbook
> Creating index for 'kde_application_manuals'
> Warning: unknown locale!
>
> New server: home, 80
> Unknown host: home

I don't quite get what khelpcenter is doing here.

Hmm, wait. I set home to point to localhost meanwhile. Removing that
khelpcenter does not crash but I get the same output (only my file is
16.6 KB)

> I noticed that htdig's debconf prompts mentioned the existence of an
> htdig3.2 package, yet I couldn't find it in the archive. It is available
> from http://users.linuxbourg.ch/ribnitz/debian, however, and while I now
> get a much longer and more promising set of errors, no index.

Yeah and looking at htdig upstream this project seems to be very slow...
The 3.2.0b6 is 12 months old.

While you found the packages, I compiled htdig3.2.0b6 from source and
installed in $HOME. But khelpcenter doesn't find htdig...

So I tried the deb and yes it seems that creating the index is comletely
broken. At least: khelpcenter tries to resolve all the help://XXX URL's
via normal DNS, which is wrong, IMHO. I'll add another comment to the
upstream bugreport...

Andreas

--
You will inherit some money or a small piece of land.

severity 313375 important
stop

On June 13, 2005 12:21, Andreas Pakulat wrote:
> So I tried the deb and yes it seems that creating the index is comletely
> broken. At least: khelpcenter tries to resolve all the help://XXX URL's
> via normal DNS, which is wrong, IMHO. I'll add another comment to the
> upstream bugreport...

Since this is really much more of an upstream bug than a missing depend, I'm
lowering the severity to important, since the bug itself is not RC. When
upstream gets its act together, then we'll add the necessary depend(s).
Until then, it/they would be superfluous.

Cheers,
Christopher Martin

* Christopher Martin [Tue, 14 Jun 2005 10:59:45 -0400]:
> then we'll add the necessary depend(s).

  Or a Recommends, perhaps?

--
Adeodato Simó
    EM: asp16 [ykwim] alu.ua.es | PK: DA6AE621

The problem I have with making an intelligent statement is that some
people then think that it's not an isolated occurrance.
                -- Simon Travaglia

On June 14, 2005 12:00, Adeodato Simó wrote:
> * Christopher Martin [Tue, 14 Jun 2005 10:59:45 -0400]:
> > then we'll add the necessary depend(s).
>
> Or a Recommends, perhaps?

Sure. I guess I should have said "package relations" :)

Stuart Gilberd (stuart-gilberd) wrote :

htdig should be a dependecy of the base kde packages

Kde 3.4.2 (and older versions)

To reproduce:
* open help for the first time
* enter something in the search box
* a dialog informs you that the index needs to be built
* step through the index building process, ticking application manuals in the what to index step
* click build index.
* the dialog tells you its 100% done (Index creation finished) - yay!
* but in reality if you happen to click details you see something like the following:

INDEXDIR: /home/sgilberd/.kde/share/apps/khelpcenter/index/
FINDCMD: find /usr/share/doc/kde/HTML/en/ -name index.docbook
Creating index for 'kde_application_manuals'
htdig failed

Alternatively you can reproduce this by using "Settings->Build Search index"

Installing htdig from synaptic fixes the problem.

Philip Cain (philipacamaniac) wrote :

KHelpCenter searching still doesn't work in Breezy snapshot 20050927. It looks
like htdig is stuck in Universe. Anyway to fix this before release?

Bug owner or priveledged user: change the affected package to khelpcenter.

Any progress on this bug? It makes the KDE help system nearly useless.

brunft (brunft) wrote :

Just came across the same problem.
Using Kubuntu Breezy final.
No error messages, error only showed up in the Details of the "Build search index" dialog.
Installed package htdig and it works now.

Matt Zimmerman (mdz) on 2006-03-31
Changed in kdebase:
assignee: nobody → jr
Changed in kdebase:
status: Unconfirmed → Confirmed

Adds htdig to the depends for kdebase

Rocco Stanzione (trappist) wrote :

I was frustrated by this as well but had no idea to install htdig

forwarded 313375 http://bugs.kde.org/show_bug.cgi?id=102912
tags 313375 + upstream
tags 313375 - experimental
stop

Just FYI, this problem is an upstream bug, reported in the KDE BTS
dozens of times, that no one can seem to be bothered to fix. Nothing
Debian specific. No version of htdig, whether present in Debian or not,
works.

Cheers,
Christopher Martin

Frode M. Døving (frode) on 2006-05-14
Changed in kdebase:
assignee: jr → kubuntu-team

severity 368208 important
merge 368208 313375
thanks

Le Sam 20 Mai 2006 16:07, Jens Rucknagel a écrit :
> Package: khelpcenter
> Version: 4:3.5.2-2+b1
>
> When I try to build a search index for the application manuals, I get
> the message:

the index for khelpcenter is completely broken, and it's a well known
fact sadly.
--
·O· Pierre Habouzit
··O <email address hidden>
OOO http://www.madism.org

# Automatically generated email from bts, devscripts version 2.9.20
forwarded 368208 http://bugs.kde.org/show_bug.cgi?id=102912

Nathan (nathan-olberding) wrote :

I can verify this bug in Kubuntu Dapper.

INDEXDIR: /home/nathano/.kde/share/apps/khelpcenter/index/
FINDCMD: find /usr/share/doc/kde/HTML/en/ -name index.docbook
Creating index for 'kde_application_manuals'
htdig failed

Installing htdig through apt, I'm informed that the htdig package has been split in to the stable and unstable packages. The stable package is installed by default. It seems the stable version should be moved to the main repositories so that it can be a KDE dependency and the unstable should be left in Universe.

Download full text (9.8 KiB)

Source: kdebase
Source-Version: 4:3.5.4-1

We believe that the bug you reported is fixed in the latest version of
kdebase, which is due to be installed in the Debian FTP archive:

kappfinder_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kappfinder_3.5.4-1_amd64.deb
kate_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kate_3.5.4-1_amd64.deb
kcontrol_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kcontrol_3.5.4-1_amd64.deb
kdebase-bin_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kdebase-bin_3.5.4-1_amd64.deb
kdebase-data_3.5.4-1_all.deb
  to pool/main/k/kdebase/kdebase-data_3.5.4-1_all.deb
kdebase-dbg_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kdebase-dbg_3.5.4-1_amd64.deb
kdebase-dev_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kdebase-dev_3.5.4-1_amd64.deb
kdebase-doc-html_3.5.4-1_all.deb
  to pool/main/k/kdebase/kdebase-doc-html_3.5.4-1_all.deb
kdebase-doc_3.5.4-1_all.deb
  to pool/main/k/kdebase/kdebase-doc_3.5.4-1_all.deb
kdebase-kio-plugins_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kdebase-kio-plugins_3.5.4-1_amd64.deb
kdebase_3.5.4-1.diff.gz
  to pool/main/k/kdebase/kdebase_3.5.4-1.diff.gz
kdebase_3.5.4-1.dsc
  to pool/main/k/kdebase/kdebase_3.5.4-1.dsc
kdebase_3.5.4-1_all.deb
  to pool/main/k/kdebase/kdebase_3.5.4-1_all.deb
kdebase_3.5.4.orig.tar.gz
  to pool/main/k/kdebase/kdebase_3.5.4.orig.tar.gz
kdepasswd_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kdepasswd_3.5.4-1_amd64.deb
kdeprint_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kdeprint_3.5.4-1_amd64.deb
kdesktop_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kdesktop_3.5.4-1_amd64.deb
kdm_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kdm_3.5.4-1_amd64.deb
kfind_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kfind_3.5.4-1_amd64.deb
khelpcenter_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/khelpcenter_3.5.4-1_amd64.deb
kicker_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kicker_3.5.4-1_amd64.deb
klipper_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/klipper_3.5.4-1_amd64.deb
kmenuedit_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kmenuedit_3.5.4-1_amd64.deb
konqueror-nsplugins_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/konqueror-nsplugins_3.5.4-1_amd64.deb
konqueror_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/konqueror_3.5.4-1_amd64.deb
konsole_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/konsole_3.5.4-1_amd64.deb
kpager_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kpager_3.5.4-1_amd64.deb
kpersonalizer_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kpersonalizer_3.5.4-1_amd64.deb
ksmserver_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/ksmserver_3.5.4-1_amd64.deb
ksplash_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/ksplash_3.5.4-1_amd64.deb
ksysguard_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/ksysguard_3.5.4-1_amd64.deb
ksysguardd_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/ksysguardd_3.5.4-1_amd64.deb
ktip_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/ktip_3.5.4-1_amd64.deb
kwin_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/kwin_3.5.4-1_amd64.deb
libkonq4-dev_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/libkonq4-dev_3.5.4-1_amd64.deb
libkonq4_3.5.4-1_amd64.deb
  to pool/main/k/kdebase/libkonq4_3.5.4-1_amd64.deb

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be c...

I'm testing this in edgy.

I'm either testing it wrong, or it's been fixed.

Can someone else confirm this bug on edgy, with kde 3.5.4?

Changed in kdebase:
status: Confirmed → Needs Info
Ryan Kavanagh (ryanakca) wrote :

I'm testing this in edgy as well.

I'm also probably testing this wrong, but instead of the error you provided, I got this error:

"
Failed to open device
Global symbol "$kdekdehtmldir" requires explicit package name at /usr/bin/khc_docbookdig.pl line 94.
Execution of /usr/bin/khc_docbookdig.pl aborted due to compilation errors.
"

Rocco Stanzione (trappist) wrote :

Same experience as Ryan. It claims to have completed successfully, but if you view the details, there's the error.

Changed in kdebase:
status: Needs Info → Confirmed
Rocco Stanzione (trappist) wrote :

Actually it fails with or without htdig. Looks like a typo on line 94 of /usr/bin/khc_docbookdig.pl - $kdekdehtmldir should be $kdehtmldir.

Rocco Stanzione (trappist) wrote :

Problem originates in debian/patches/25_khelp_htdig.diff in kdebase. That doesn't solve this bug, but htdig will fail no matter what until it's fixed.

Rocco Stanzione (trappist) wrote :

This fixes the aforementioned issue, but not the original bug.

Andrew Hunter (rexbron) wrote :

Adding a "me too" to Ryans error. This was a problem on Dapper as well as Edgy(kubuntu RC, KDE 3.5.5). My personal inclination is to mark this bugs priority as High (even though it is an easy [I think] fix). IMHO, it is pretty severe when you can not create a search index for the help files.

Christian Reis (kiko) wrote :

Note that bug 36865 has a debian bug watch that is missing from here.

@Christian,

Done. Thanks for pointing it out.

Richard Johnson (nixternal) wrote :

This will always be a problem because htdig is no longer maintained, and hasn't been maintained. BUT... We can some how grab the version OpenSUSE uses as it works great there, or we work with the Strigi guys to get it implemented into KHelpCenter. This is what we are currently working on with the KDE doc/dev team with Strigi.

Changed in kdebase:
status: Unknown → Fix Released
Brian Murray (brian-murray) wrote :

This is still an issue with Feisty Fawn Herd 5.

Brian Murray (brian-murray) wrote :

Richard - What do you mean htdig is no longer maintained? It is installable in Feisty ( htdig | 1:3.2.0b6-3 | http://us.archive.ubuntu.com feisty/universe Packages ) and it seems that making it a dependency would resolve this issue.

it's installable, but that does not mean it's being maintained. The debian maintainer orphaned this package long ago, and until this package has someone who wants to maintain it (and fix the CVE's for it), it will not make it into main, hence it wont be able to be a dependancy.

Brian Murray (brian-murray) wrote :

Sarah thanks for the additional information that is good to know.

Scott Beamer (angrykeyboarder) wrote :

And another confirmation..

I'm running (K)Ubuntu Feisty (i386)
-----------------------------------------------------------------------

Failed to open device
X Error: BadDevice, invalid or uninitialized input device 169
  Major opcode: 147
  Minor opcode: 3
  Resource id: 0x0
Failed to open device
INDEXDIR: /home/scott/.kde/share/apps/khelpcenter/index/
FINDCMD: find /usr/share/doc/kde/HTML/en/ -name index.docbook
Creating index for 'kde_application_manuals'
htdig failed

-----------------------------------------------------------------------

Scott Beamer (angrykeyboarder) wrote :

I don't know if this would be part of this same bug or not but...

After I installed htdig, opned KDE Help Center and built the search index, it appared to do so, but with the following errors.:

-----------------------------------------------------------------------

X Error: BadDevice, invalid or uninitialized input device 169
  Major opcode: 147
  Minor opcode: 3
  Resource id: 0x0
Failed to open device
X Error: BadDevice, invalid or uninitialized input device 169
  Major opcode: 147
  Minor opcode: 3
  Resource id: 0x0
Failed to open device
INDEXDIR: /home/scott/.kde/share/apps/khelpcenter/index/
FINDCMD: find /usr/share/doc/kde/HTML/en/ -name index.docbook
Creating index for 'kde_application_manuals'
ht://dig Start Time: Sat May 19 13:03:37 2007
Warning: unknown locale!

[......]

144:177:1:help://klinkstatus/index.docbook: size = 14225
index.docbook:1: parser error : SystemLiteral " or ' expected

                                                                         ^
index.docbook:1: parser error : SYSTEM or PUBLIC, the URI is missing

                                                                         ^
index.docbook:2: parser error : xmlParseEntityDecl: entity kappname not terminated
  </i>
                               ^
index.docbook:2: parser error : internal error
  </i>
                               ^
index.docbook:2: parser error : DOCTYPE improperly terminated
  </i>
                               ^
index.docbook:2: parser error : Start tag expected, '
  </i>
                                ^

[......]

I/O warning : failed to load external entity "circuits.docbook"
index.docbook:51: parser error : Failure to process entity ktechlab-circuits
 </i>
                    ^
index.docbook:51: parser error : Entity 'ktechlab-circuits' not defined
 </i>
                    ^
I/O warning : failed to load external entity "microbe.docbook"
index.docbook:53: parser error : Failure to process entity ktechlab-microbe
 </i>
                   ^
index.docbook:53: parser error : Entity 'ktechlab-microbe' not defined
 </i>
                   ^
I/O warning : failed to load external entity "faq.docbook"
index.docbook:55: parser error : Failure to process entity ktechlab-faq
 </i>
               ^
index.docbook:55: parser error : Entity 'ktechlab-faq' not defined
 </i>
               ^

[......]

htdig: Errors to take note of:
Unknown host or unable to contact server: help://kregexpeditor/index.docbook Ref: file:///home/scott/.kde/share/apps/khelpcenter/index/kde_application_manuals.tmp/index.html

[......]

-----------------------------------------------------------------------

I've attached a copy of the full output

Robert Persson (ireneshusband) wrote :

I think this bug should have a much higher priority.

Imagine you know little about Linux, or even about any kind of operating system. You install Kubuntu because you want a nice user-friendly desktop environment, but the help system upon which you depend to find your way around won't answer your questions. IMO that is a real blocker.

If a fundamental feature of KDE just won't work without htdig, then htdig just has to be pulled in as a dependency, maintained or not.

Guillaume Martres (smarter) wrote :

This bug is still present on Gutsy, additionaly you must do "sudo ln -sf /bin/bash /bin/sh" to make it work.

tuxo (beat-fasel) wrote :

The KDE helpcenter (KDE version 3.5.8) still has no working search facility after the release of Gutsy Gibbon. Apparently, the reason is the missing htdig search system that is not installed as it is not maintained anymore. As has been mentioned 9 months ago by another poster in this bug report, Strigi might be an alternative to htdig, especially that it is now included by default in Gutsy. I really hope that this bug gets some attention. I have seen more than one new Kubuntu user that tried to use the search facility of the KDE Helpcenter and becoming very frustrated.

keyboardashtray (tonyg100) wrote :

So in the meantime, until this is fixed, is the way to get the search index in KDE help center to work to install htdig, and then enter "sudo ln -sf /bin/bash /bin/sh" like Guillaume said?

Changed in kdebase:
assignee: kubuntu-team → nobody

Still fails in Hardy,

And after installing htdig it still fails, problem is still what Rocco said:
"Looks like a typo on line 94 of /usr/bin/khc_docbookdig.pl - $kdekdehtmldir should be $kdehtmldir."
Editing that fixes the problem.

Cyril Buquet (cyril11) wrote :
Download full text (29.3 KiB)

Same for Hardy,

I use this solution :
1) sudo apt-get install htdig
2) sudo vi /usr/bin/khc_docbookdig.pl
>>> change : my $findpath = "$kdekdehtmldir/$lang/";
>>> with : my $findpath = "$kdehtmldir/$lang/";
(line 94)

Result :

INDEXDIR: /home/cyril/.kde/share/apps/khelpcenter/index/
FINDCMD: find /usr/share/doc/kde/HTML/en/ -name index.docbook
Creating index for 'kde_application_manuals'
ht://dig Start Time: Thu May 8 18:12:40 2008
Warning: unknown locale!

New server: localhost, 0
0:2:0:file:///home/cyril/.kde/share/apps/khelpcenter/index/kde_application_manuals.tmp/index.html:
New server: kpat, 80
+
New server: kompmgr, 80
+
New server: kdesudo, 80
+
New server: kio-locate, 80
+
New server: kwrite, 80
+
New server: gwenview, 80
+
New server: kdat, 80
+
New server: kspell, 80
+
New server: kcron, 80
+
New server: kamera, 80
+
New server: kdcop, 80
+
New server: kpf, 80
+
New server: kmix, 80
+
New server: khelpcenter, 80
++++++
New server: konsole, 80
+
New server: kdesu, 80
+
New server: kcontrol, 80
++++++++++++++++++++++++++++++++++++++++++++++
New server: katapult, 80
+
New server: kfind, 80
+
New server: kioslave, 80
+
New server: kopete, 80
+
New server: ksysguard, 80
+
New server: korganizer, 80
+
New server: karm, 80
+
New server: kghostview, 80
+
New server: kppp, 80
+
New server: ksirtet, 80
+
New server: kdeprint, 80
+
New server: krdc, 80
+
New server: kmenuedit, 80
+
New server: kinfocenter, 80
+++++++++++++++++++
New server: kdm, 80
+
New server: kpdf, 80
+
New server: kexi, 80
+
New server: kooka, 80
+
New server: kdebugdialog, 80
+
New server: ark, 80
+
New server: konversation, 80
+
New server: d3lphin, 80
+
New server: kdebluetooth, 80
+
New server: konqueror, 80
+
New server: akregator, 80
+
New server: kmines, 80
+
New server: kicker, 80
+
New server: knetworkconf, 80
+
New server: k3b, 80
+
New server: amarok, 80
+
New server: kmousetool, 80
+
New server: kmail, 80
+
New server: krfb, 80
+
New server: kwallet, 80
+
New server: ksplashml, 80
+
New server: koffice, 80
+
New server: klipper, 80
+
New server: kmag, 80
+
New server: kget, 80
+
New server: kontact, 80
+
New server: kaddressbook, 80
+
New server: konq-plugins, 80
+++++++++++++
New server: ksnapshot, 80
+
New server: kxkb, 80
+
New server: kate, 80
+
New server: kaffeine, 80
+
New server: krita, 80
+
New server: knetattach, 80
+
New server: knotes, 80
+
New server: koverartist, 80
+ size = 15324
/home/cyril/.kde/share/apps/khelpcenter/index//kde_application_manuals.tmp/docbookparser: 11: Bad substitution
1:79:1:help://ksirtet/index.docbook: size = 15901
/home/cyril/.kde/share/apps/khelpcenter/index//kde_application_manuals.tmp/docbookparser: 11: Bad substitution
2:4:1:help://kompmgr/index.docbook: size = 14483
/home/cyril/.kde/share/apps/khelpcenter/index//kde_application_manuals.tmp/docbookparser: 11: Bad substitution
3:24:1:help://kcontrol/kcmsmserver/index.docbook: size = 3537
/home/cyril/.kde/share/apps/khelpcenter/index//kde_application_manuals.tmp/docbookparser: 11: Bad substitution
4:69:1:help://kcontrol/filetypes/index.docbook: size = 13233
/home/cyril/.kde/share/apps/khelpcenter/index//kde_application_manuals.tmp/docbookparser: 11: Bad sub...

mugginz (mugginz1) wrote :

 Cyril BUQUET,

Unfortunately the failure you're having is another example of dash breaking something.

I did what you suggested
1) sudo apt-get install htdig
2) sudo vi /usr/bin/khc_docbookdig.pl
>>> change : my $findpath = "$kdekdehtmldir/$lang/";
>>> with : my $findpath = "$kdehtmldir/$lang/";
(line 94)

But then had to change the sym link for /bin/sh from dash to bash.
3) sudo mv /bin/sh /bin/sh.old
4) sudo ln -s /bin/bash /bin/sh

And then when I re-ran the index build it worked.

Probably would be better to change the script that the help indexer uses to explicitly call /bin/bash instead of /bin/sh though.

mugginz (mugginz1) wrote :

The following file
        "~/.kde/share/apps/khelpcenter/index/kde_application_manuals.tmp/docbookparser"
is where the show stops.

It needs line 1 changed from
#! /bin/sh
    to
#! /bin/bash

The above file's created from inside the following python script
        "/usr/bin/khc_docbookdig.pl"

The source for the python script is
        "kdebase-3.5.9/khelpcenter/searchhandlers/khc_docbookdig.pl.in"

Now all we have to do is get this file changed in the distro.

skierpage (skierpage) wrote :

The completely broken Help Search continues with KHelpCenter 4.2.2 (KDE 4.2.3) in Kubuntu 9.04 Jaunty (amd64). htdig is STILL not a dependency of KDE packages or khelpcenter4. KPackageKit lists a "htdig - 1:3.2.0b6-8"; its Required by is empty, as is its File List (??!).

I installed this htdig package, and then KHelpCenter's [Build Search Index...] built me a new index, ending with ""ht://dig ... Finished successfully" and it seemingly worked. There were no problems with bash or perl files as other comments here report with Hardy.

Please just add htdig as a dependency to khelpcenter4, as has been done in Debian lenny! Compare http://packages.ubuntu.com/jaunty/khelpcenter4 with http://packages.debian.org/lenny/khelpcenter4.

Myriam Schweingruber (myriam) wrote :

This bug is here since 2005, could we put it in higher priority please? Not having a working KDE help system for the basic user in Kubuntu is really not acceptable.
The workaround is doable, but this is hardly something one can expect from a basic user who already has a hard time finding his/her way around. And has no hel system available...

Harald Sitter (apachelogger) wrote :

A higher priority does not change the fact that Kubuntu does not have the resources, nor does any team member have interest to rewrite KHelpCenter. Same applies for KDE.

Just adding htdig is not the solutions as it was probably stated in some comment above that it is horrible junk, dragging in more horrible junk, not working reliably once it junked it's way through all the docbooks, in case it even manages to do that without falling apart, and even if all that weren't the case it still would not resolve all the other shortcomings, bottlenecks and usability issues that make it the second most awful application in core KDE (kuser being the most awful one).

From my point of view Medium is too high already, since there are much more awkward issues and since this issues is only part of the bigger one that KHC is unmaintained for the better part.
Simply put: KHC needs a rewrite

art alexion (art-alexion) wrote :

I find Harald's response troubling and totally agree with Myriam. I don't use the help system much any more, but new users and what she describes as "basic" users, need a working help system.

With all of the "horrible junk" already a part of the default kubuntu install, a working help system seems worth it.

I see the problem is that htdig is not supported and maintained, yet to properly work, khelpcenter should depend on it. I don't think Kubuntu should depend on something unmaintained, but I think it is detrimental to Ubuntu to expose a feature that is non-functionnal.

I think the middle ground would be completely disabling the search feature if it cannot work, saying htdig should be installed. People would at least know this is not working, why it doesn't work, and how to make it work if they want to.

skierpage (skierpage) wrote :

Harald, I value your comments and blog, but this bug is about KDE help search failing because of htdig. In my experience as a n00b with Jaunty, installing htdig didn't "drag in more horrible junk", it simply made KHC search work -- badly, but FAR better than total failure. I humbly submit that the one-line packaging change to add htdig as a dependency (as Debian Lenny has done) will fix this bug in Jaunty and Karmic.

"KHC needs a rewrite" is a different bug. I couldn't find it in Launchpad or at bugs.kde.org, the closest I could find is "Add Builtin Help Center Search Facility Indexer", https://bugs.kde.org/show_bug.cgi?id=93664 . And some interesting posts about using strigi or QtHelp or whatever.

Francois-Denis, FWIW on MS-Windows, KHelpCenter has no Search tab but I can't figure out how it's disabled. If it were easy to configure then I agree Kubuntu could disable the search tab and add more instructions to enabling search.

Where's a good place to document this problem and the workaround ? I couldn't find "Kubuntu 9.04 release notes" anywhere, and perhaps http://www.ubuntu.com/getubuntu/releasenotes/904 is too general for KDE Help Center.

skierpage (skierpage) wrote :

If someone decides the resolution of this bug is really to disable the Search tab rather than make htdig a dependency...

From http://lxr.kde.org/source/KDE/kdebase/runtime/khelpcenter/searchengine.cpp#217 , if you don't have anything useful in ${DATA_INSTALL_DIR}/khelpcenter/searchhandlers , then KHelpCenter calls hideSearch(). This directory isn't installed on Windows, hence there's no Search tab in KDE-Windows. I think renaming it or its contents to searchhandlers_DISABLED would do the trick in Kubuntu.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package kdebase-runtime - 4:4.4.2-0ubuntu2

---------------
kdebase-runtime (4:4.4.2-0ubuntu2) lucid; urgency=low

  [ Brandon Holtsclaw ]
  * Removed searchhandlers from being installed to hide the search tab in
    khelpcenter4 (htdig broken/not in main) Closes (LP: #19767)

  [ Jonathan Thomas ]
  * Backport kubuntu_91_set_US_time_format.diff from upstream's 4.4 branch to
    properly set a timezone for US users.

  [ Scott Kitterman ]
  * Update debian/copyright from Debian (Thanks to Ferdinand Thommes)
 -- Scott Kitterman <email address hidden> Sun, 11 Apr 2010 23:39:59 -0400

Changed in kdebase-runtime (Ubuntu):
status: Confirmed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Bug attachments

Remote bug watches

Bug watches keep track of this bug in other bug trackers.